using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace BmxCs {
	/// <summary>
	/// BMxt@C̃wb_i[NXB
	/// </summary>
	public class BmxHeader {
		// ̎B
		// WAVxxƂ̂܂ܓĂ܂B
		Dictionary<string, string> headers = new Dictionary<string,string>();

#if DEBUG
		public Dictionary<string, string> GetDictionary() {
			return headers;
		}
#endif

		/// <summary>
		/// ǂݎwb_̈ꗗAw̃wb_𓾂B
		/// </summary>
		/// <param name="key">擾wb_</param>
		/// <returns>wb_̒lB`݂̂ŒlȂꍇ͋󕶎A`ĂȂꍇnullԂB</returns>
		public string this[string key] {
			get {
				string k = key.ToUpper();

				string ret = null;
				if (headers.ContainsKey(k)) {
					ret = headers[k];
					Debug.WriteLine(string.Format("{0} -> {1}", k, ret), "Header Access");
					if (ret == null) ret = "";
				}
				else {
					Debug.WriteLine(string.Format("NotFound : {0}", k), "Header Access");
				}


				return ret;
			}
			set {
				headers[key.ToUpper()] = value ?? "";
			}
		}

		public string GetDefinition(string type, int index) {
			return this[type.ToUpper() + Base36.ToBase36(index)];
		}

		public string GetWAV(int index) {
			return GetDefinition("WAV", index);
		}

		public string GetBMP(int index) {
			return GetDefinition("BMP", index);
		}

		public string GetBPM(int index) {
			return GetDefinition("BPM", index) ?? GetDefinition("EXBPM", index);
		}

		public string GetTEXT(int index) {
			return GetDefinition("TEXT", index);
		}

		public string GetSTOP(int index) {
			return GetDefinition("STOP", index) ?? GetDefinition("STP", index);
		}
	}
}
