using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;

namespace BmxCs {
	/// <summary>
	/// e߂ɂACxgf[^i[NXB
	/// </summary>
	public class BmxScore {
		/// <summary>
		/// 1ߓ̏߃f[^B\͊St[(̋)
		/// </summary>
		public class BarEvent {
			// 悭lĂ݂瓯^C~Oɓ`l̃Cxg邱Ƃ̂
			// XgɕύXB
			// ɁA\̂(ߒύXƂ)floatɕύXB
			List<float>[] data = null;
			bool initialized = false;

			/// <summary>
			/// w肵^C~OɂCxg̃Xg擾B
			/// </summary>
			/// <param name="tick">擾^C~O</param>
			/// <returns>Cxgi[ꂽIList&lt;float&gt;</returns>
			public IList<float> this[int tick] {
				get {
					return initialized ? data[tick] : null;
				}
			}

			/// <summary>
			/// ̏߂̕BlȂƂɂ0B
			/// </summary>
			public int DivisionNum {
				get {
					return initialized ? data.Length : 0;
				}
			}

			/// <summary>
			/// ̏߃f[^Lȃf[^킹Ă邩B
			/// </summary>
			public bool IsValid {
				get { return initialized; }
			}

			/// <summary>
			/// f[^ǉB
			/// </summary>
			/// <param name="src">ǉꏬ߃f[^Bf[^éABMSdl̈s̋LqɏB</param>
			public void AddData(IList<float> src) {
				int srclen = src.Count;

				// ׂĂ̗vf0ꍇ͋pB
				// ́AׂẴ`lɂĐB
				{
					bool flag = false;
					foreach (float f in src) {
						if (f != 0.0f) {
							flag = true;
							break;
						}
					}

					if (!flag) return;
				}


				ExtendDivision(srclen);

				int span = data.Length / srclen;

				for (int i = 0; i < srclen; i++) {
					if (data[i * span] == null)
						data[i * span] = new List<float>(1);

					if (src[i] != 0.0)
						data[i * span].Add(src[i]);
				}

			}

			/// <summary>
			/// w肵̃f[^悤ATCYgB
			/// </summary>
			/// <param name="size">ƂȂ镪B</param>
			public void ExtendDivision(int size) {
				if (!initialized) {
					data = new List<float>[size];
					initialized = true;
					return;
				}

				int newsize = data.Length * size / GCD(data.Length, size);

				if (newsize > data.Length) {
					int len = data.Length;
					// ̂Q͐ɂȂ͂
					int span = newsize / len;

					List<float>[] ret = new List<float>[newsize];

					// VzɌÂf[^U蕪B
					for (int i = 0; i < len; i++) {
						ret[i * span] = data[i];
					}

					// Vzɓւ
					data = ret;
				}
			}

			/// <summary>
			/// ő񐔂߂B
			/// </summary>
			/// <param name="a">߁B</param>
			/// <param name="b">߁B</param>
			/// <returns>̒lB</returns>
			private static int GCD(int a, int b) {
				if (a < 0)
					throw new ArgumentException("̒l͎gpł܂B", "a");
				if (b < 0)
					throw new ArgumentException("̒l͎gpł܂B", "b");

				if (b != 0) {
					do {
						int r = a % b;

						a = b;
						b = r;
					} while (b != 0);
				}

				return a;

			}

		}

		/// <summary>
		/// 郌[
		/// </summary>
		public class Channel {
			List<BarEvent> events;

			public Channel() {
				events = new List<BarEvent>();
			}

			/// <summary>
			/// ̃[Ă鏬ߐB
			/// </summary>
			public int Size {
				get { return events.Count; }
			}

			/// <summary>
			/// w肵ߔԍ̏߃f[^擾BnullLB
			/// </summary>
			/// <param name="index">ߔԍ</param>
			/// <returns>߃f[^BȂꍇɂnullB</returns>
			public BarEvent this[int index] {
				get {
					return events.Count > index ? events[index] : null;
				}
			}

			/// <summary>
			/// w肵ߔԍ̏߃f[^擾B
			/// CX^XȂꍇɂ͍쐬B
			/// </summary>
			/// <param name="index">ߔԍ</param>
			/// <returns>߃f[^BKlB</returns>
			public BarEvent GetBarEvent(int index) {
				while (events.Count <= index)
					events.Add(null);

				return events[index] ?? (events[index] = new BarEvent());
			}

		}

		Channel[] channels;

		public BmxScore() {
			channels = new Channel[0xFF];

			for (int i = 0; i < 0xFF; i++) {
				channels[i] = new Channel();
			}

		}

		/// <summary>
		/// w肵ԍ̃`lf[^擾B
		/// </summary>
		/// <param name="index">`lԍ</param>
		/// <returns>`lf[^BɒlB</returns>
		public Channel this[int index] {
			get { return channels[index]; }
		}

		

	}
}
